--- CMake/Templates/SDK_CMakeLists.txt.in.orig	2011-05-08 20:28:04.000000000 +0200
+++ CMake/Templates/SDK_CMakeLists.txt.in	2011-11-11 05:24:02.000000000 +0100
@@ -36,12 +36,24 @@
 
 project(OGRE)
 
+set(MACPORTS @MACPORTS@ CACHE BOOL "Build OGRE Samples for MacPorts")
+set(MACPORTS_CMAKE_MODULE_PATH "@MACPORTS_CMAKE_MODULE_PATH@" CACHE STRING
+  "The path to MacPorts user-installed CMake modules")
+set(MACPORTS_CONFIGFILE_PATH "@CMAKE_INSTALL_PREFIX@/@OGRE_CFG_INSTALL_PATH@" CACHE STRING
+  "The path to the MacPorts install of config files")
+
 # Find actual Ogre root
 if (WIN32 OR APPLE)
   get_filename_component(OGRE_ROOT_DIR "${OGRE_SOURCE_DIR}" ABSOLUTE)
-  set(OGRE_TEMPLATES_DIR "${OGRE_ROOT_DIR}/cmake")
-  set(OGRE_WORK_DIR "${OGRE_ROOT_DIR}")
-  set(CMAKE_MODULE_PATH "${OGRE_ROOT_DIR}/cmake")
+  if (NOT MACPORTS)
+    set(OGRE_TEMPLATES_DIR "${OGRE_ROOT_DIR}/cmake")
+    set(OGRE_WORK_DIR "${OGRE_ROOT_DIR}")
+    set(CMAKE_MODULE_PATH "${OGRE_ROOT_DIR}/cmake")
+  else()
+    set(OGRE_TEMPLATES_DIR "@MACPORTS_CMAKE_TEMPLATES_DIR@")
+    set(OGRE_WORK_DIR "${OGRE_ROOT_DIR}")
+    list(APPEND CMAKE_MODULE_PATH ${MACPORTS_CMAKE_MODULE_PATH})
+  endif()
 elseif (UNIX)
   get_filename_component(OGRE_ROOT_DIR "${OGRE_SOURCE_DIR}/../.." ABSOLUTE)
   set(OGRE_TEMPLATES_DIR "${OGRE_ROOT_DIR}/lib/OGRE/cmake")
@@ -166,11 +178,21 @@
     include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include/OGRE/iPhone")
   else ()
     # Set 10.5 as the base SDK by default
-    set(XCODE_ATTRIBUTE_SDKROOT macosx)
-    set(CMAKE_OSX_SYSROOT macosx)
+    #set(XCODE_ATTRIBUTE_SDKROOT macosx)
+    #set(CMAKE_OSX_SYSROOT macosx)
     set(CMAKE_OSX_DEPLOYMENT_TARGET 10.5)
-    set(CMAKE_OSX_ARCHITECTURES $(ARCHS_STANDARD_32_64_BIT))
-    include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include/OGRE/OSX")
+
+    if (NOT CMAKE_OSX_ARCHITECTURES)
+      if (ARCHS_STANDARD_32_64_BIT)
+	set(CMAKE_OSX_ARCHITECTURES $(ARCHS_STANDARD_32_64_BIT))
+      endif()
+    endif()
+
+    if (NOT MACPORTS)
+      include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include/OGRE/OSX")
+    else()
+      include_directories("${OGRE_CONFIG_INCLUDE_DIR}/OSX")
+    endif()
   endif ()
 endif (APPLE)
 
